/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "sprites.h"

#define __KEYBIOS_H__
#include "fxlib.h"
#define KEY_CHAR_0 71
#define KEY_CHAR_1 72
#define KEY_CHAR_2 62
#define KEY_CHAR_3 52
#define KEY_CHAR_4 73
#define KEY_CHAR_5 63
#define KEY_CHAR_6 53
#define KEY_CHAR_7 74
#define KEY_CHAR_8 64
#define KEY_CHAR_9 54
#define KEY_CHAR_DP 61
#define KEY_CHAR_EXP 51
#define KEY_CHAR_PMINUS 41
#define KEY_CHAR_PLUS 42
#define KEY_CHAR_MINUS 32
#define KEY_CHAR_MULT 43
#define KEY_CHAR_DIV 33
#define KEY_CHAR_FRAC 75
#define KEY_CHAR_LPAR 55
#define KEY_CHAR_RPAR 45
#define KEY_CHAR_COMMA 35
#define KEY_CHAR_STORE 25
#define KEY_CHAR_LOG 66
#define KEY_CHAR_LN 56
#define KEY_CHAR_SIN 46
#define KEY_CHAR_COS 36
#define KEY_CHAR_TAN 26
#define KEY_CHAR_SQUARE 67
#define KEY_CHAR_POW 57
#define KEY_CTRL_EXE 31
#define KEY_CTRL_DEL 44
#define KEY_CTRL_AC 32
#define KEY_CTRL_FD 65
#define KEY_CTRL_EXIT 47
#define KEY_CTRL_SHIFT 78
#define KEY_CTRL_ALPHA 77
#define KEY_CTRL_OPTN 68
#define KEY_CTRL_VARS 58
#define KEY_CTRL_UP 28
#define KEY_CTRL_DOWN 37
#define KEY_CTRL_LEFT 38
#define KEY_CTRL_RIGHT 27
#define KEY_CTRL_F1 79
#define KEY_CTRL_F2 69
#define KEY_CTRL_F3 59
#define KEY_CTRL_F4 49
#define KEY_CTRL_F5 39
#define KEY_CTRL_F6 29
#define KEY_CTRL_MENU 48
#ifndef OS2Change
#define OS2Change
#ifndef OS2Change_GetOS2
#define OS2Change_GetOS2
typedef int(*sc_i2cp2sip)(char*, char*, short int*, short int*);
const unsigned int sc0015[] = { 0xD201D002, 0x422B0009, 0x80010070, 0x0015 };
#define GlibGetOSVersionInfo (*(sc_i2cp2sip)sc0015)
int OSVersionAsInt(void)
{
unsigned char mainversion;
unsigned char minorversion;
unsigned short release;
unsigned short build;
GlibGetOSVersionInfo( &mainversion, &minorversion, &release, &build );
return ( ( mainversion << 24 ) & 0xFF000000 ) | ( ( minorversion << 16 ) & 0x00FF0000 ) | ( release & 0x0000FFFF );
}
#define isOS2 (OSVersionAsInt() >= 0x02020000)
#define OS2(x,y) ((OSVersionAsInt() >= 0x02020000)?y:x)
#endif
#ifndef OS2Change_Keyboard
#define OS2Change_Keyboard
void delay(void)
{
char i;
for (i=0; i<5; i++){};
}
unsigned char CheckKeyRow(unsigned char code)
{
unsigned char result=0;
short*PORTB_CTRL=(void*)0xA4000102;
short*PORTM_CTRL=(void*)0xA4000118;
char*PORTB=(void*)0xA4000122;
char*PORTM=(void*)0xA4000138;
char*PORTA=(void*)0xA4000120;
short smask;
char cmask;
unsigned char column, row;
column = code>>4;
row = code &0x0F;
smask = 0x0003 << (( row %8)*2);
cmask = ~( 1 << ( row %8) );
if(row <8)
{
  *PORTB_CTRL = 0xAAAA ^ smask;
  *PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
  delay();
  *PORTB = cmask;
  *PORTM = (*PORTM & 0xF0 ) | 0x0F;
}
else
{
  *PORTB_CTRL = 0xAAAA;
  *PORTM_CTRL = ((*PORTM_CTRL & 0xFF00 ) | 0x00AA)  ^ smask;
  delay();
  *PORTB = 0xFF;
  *PORTM = (*PORTM & 0xF0 ) | cmask;
}

delay();
result = (~(*PORTA))>>column & 1;
delay();
*PORTB_CTRL = 0xAAAA;
*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
delay();
*PORTB_CTRL = 0x5555;
*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x0055;
delay();

return result;
}

unsigned char KeyDown(unsigned char keycode)
{
unsigned short key[8];
const unsigned short* keyboardregister = (unsigned short*)0xA44B0000;
if(isOS2)
{
  unsigned char row = keycode%10;
  memcpy(key, keyboardregister, sizeof(unsigned short) << 3);
 
  return (0 != (key[row >> 1] & 1 << keycode / 10 - 1 + ((row & 1) << 3)));
}
else
{
  return CheckKeyRow((keycode % 10) + ((keycode / 10 - 1) << 4));
}
}
unsigned char GetKeyMod(unsigned int *key)
{
unsigned char x, ret;

ret = GetKey(key);

for(x = 0; x < 80; x++)
{
  if(KeyDown(x))
  {
   *key = x;
   break;
  }
}
return ret;
}
#define IsKeyDown(x) KeyDown(x)
#define IsKeyUp(x) !KeyDown(x)
#define GetKey(x) GetKeyMod(x)
#endif
#endif

//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************

unsigned int key;
char strx[50];
char stry[50];
int carte[6][8]={{-1,-1,-1,-1,-1,-1,-1,-1},{-1,-1,-1,-1,-1,-1,-1,-1},{-1,-1,-1,-1,8,9,7,-1},{-1,-1,-1,-1,4,3,6,-1},{-1,1,-1,-1,-1,-1,-1,-1},{-1,-1,-1,-1,-1,-1,-1,-1}};
const char *sprites[10]={piece,Arbre1,porteA,fenetreM_rc,murG_rc,murM_rc,porteD,toitD,toitG,toitM};
int i=0,j=0,x=-24,y=-46,test=0,map=0,animationUP=0,animationLEFT=0,animationDOWN=0,animationRIGHT=0,direction=1;
int AddIn_main(int isAppli, unsigned short OptionNum)
{
    while(key!=KEY_CTRL_EXIT){
        map_draw(x,y,direction);
        key=0;
        GetKey(&key);
        switch(key){
            case KEY_CTRL_UP:
                if (map_test(x,y,1)==1)break;
                y++;
                direction=1;
                break;
            case KEY_CTRL_LEFT:
                if (map_test(x,y,4)==1)break;
                x++;
                direction=4;
                break;
            case KEY_CTRL_RIGHT:
                if(map_test(x,y,2)==1)break;
                x--;
                direction=2;
                break;
            case KEY_CTRL_DOWN:
                if(map_test(x,y,3)==1)break;
                y--;
                direction=3;
                break;
            case KEY_CTRL_ALPHA:
                if (map==0 && (x==-35 && y==0)){
                    x=-43;
                    y=-8;
                    map=1;
                    direction=1;
                }
                else if(map==1 && (x==-43 && y==-8)){
                    x=-35;
                    y=0;
                    map=0;
                    direction=3;
                }
                break;
        };
    };
    
    return 1;
}

map_draw(int coordx,int coordy,int direction)
{
    ML_clear_vram();
    sprintf(strx,"x=%d",x);
    sprintf(stry,"y=%d",y);
    PrintMini(10,10,strx,0);
    PrintMini(10,25,stry,0);
    
    switch (direction)
    {
        case 1:
            animationUP=(animationUP+1)%2;
            if(animationUP==0)ML_bmp_or(joueurDo1,54,22,20,20);
            else
            {
                ML_bmp_or(joueurDo2,54,22,20,20);
            }
            break;
        case 2:
            animationRIGHT=(animationRIGHT+1)%2;
            if(animationRIGHT==0)ML_bmp_or(joueurDr1,54,22,20,20);
            else
            {
                ML_bmp_or(joueurDr2,54,22,20,20);
            }
            break;
        case 3:
            animationDOWN=(animationDOWN+1)%2;
            if(animationDOWN==0)ML_bmp_or(joueurF1,54,22,20,20);
            else
            {
                ML_bmp_or(joueurF2,54,22,20,20);
            }
            break;
        case 4:
            animationLEFT=(animationLEFT+1)%2;
            if(animationLEFT==0)
            {
                ML_bmp_or(joueurG1,54,22,20,20);
            }
            else
            {
                ML_bmp_or(joueurG2,54,22,20,20);
            }
            break;
    }
    if (map==0){
        for(i=0;i<6;i++)
        {
            for(j=0;j<8;j++)
            {
                test=carte[i][j];
                if(carte[i][j]>=0)ML_bmp_or_cl(sprites[test],coordx+j*16,coordy+i*16,16,16);
            }
        }
        ML_display_vram();
        /*ML_bmp_or_cl(Arbre1,coordx,coordy,64,62);
        ML_bmp_or_cl(murG_rc,coordx+60,coordy+10,16,16);
        ML_bmp_or_cl(fenetreM_rc,coordx+76,coordy+10,16,16);
        ML_bmp_or_cl(porteD,coordx+92,coordy+10,16,16);
        ML_bmp_or_cl(toitG,coordx+60,coordy-6,16,16);
        ML_bmp_or_cl(toitM,coordx+76,coordy-6,16,16);
        ML_bmp_or_cl(toitD,coordx+92,coordy-6,16,16);*/
    }
    if (map==1){
        ML_bmp_or_cl(piece,coordx,coordy,128,64);
        ML_bmp_or_cl(porteA,coordx+108,coordy+54,8,9);
    }
    ML_bmp_and(interface2,0,0,128,64);
    ML_bmp_or(interface,0,0,128,64);
}
int map_test(int x,int y,int direction)
{
    /*if(map==0){
        if (direction==1){
            if (y==0 && (-3>=x && x>=-43)||y==-40 && (61>=x && x>=5)){
                return 1;
            }
        }
        if(direction==2){
            if(x==69 && (40>=y && y>=-32)){
                return 1;
            }
        }
        if(direction==3){
            if(y==48 && (61>=x && x>=-43)){
                return 1;
            }
        }
        if (direction==4){
            if (x==-3 && (30>=y && y>=-32)||x==-51 && (40>=y && y>=8)){
                return 1;
            }
        }
        
    }*/
    if (map==1){
        if (direction==1){
            if (y==16 && (45>=x && x>=-43)){
                return 1;
            }
        }
        if(direction==2){
            if(x==-43 && (16>=y && y>=-8)){
                return 1;
            }
        }
        if(direction==3){
            if(y==-8 && (45>=x && x>=-43)){
                return 1;
            }
        }
        if (direction==4){
            if (x==45 && (16>=y && y>=-8)){
                return 1;
            }
        }
    }
    
    return 0;
}


//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

